grails-app/domain/homeautomation/Log.groovy
package homeautomation

class Log {
    Date dateCreated
    String deviceName
    boolean deviceMode

    static constraints={
        deviceName(nullable:false)
        deviceMode(nullable:false)
    }

    static belongsTo=[device:Device]
}

grails-app/controllers/homeautomation/LogController.groovy
package homeautomation

import static org.springframework.http.HttpStatus.*
import grails.transaction.Transactional

@Transactional(readOnly = true)
class LogController {

    static allowedMethods = [save: "POST", update: "PUT", delete: "DELETE"]

    def index(Integer max) {
        params.max = Math.min(max ?: 10, 100)
        respond Log.list(params), model:[logCount: Log.count()]
    }

    def show(Log log) {
        respond log
    }

    def create() {
        respond new Log(params)
    }

    @Transactional
    def save(Log log) {
        if (log == null) {
            transactionStatus.setRollbackOnly()
            notFound()
            return
        }

        if (log.hasErrors()) {
            transactionStatus.setRollbackOnly()
            respond log.errors, view:'create'
            return
        }

        log.save flush:true

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.created.message', args: [message(code: 'log.label', default: 'Log'), log.id])
                redirect log
            }
            '*' { respond log, [status: CREATED] }
        }
    }

    def edit(Log log) {
        respond log
    }

    @Transactional
    def update(Log log) {
        if (log == null) {
            transactionStatus.setRollbackOnly()
            notFound()
            return
        }

        if (log.hasErrors()) {
            transactionStatus.setRollbackOnly()
            respond log.errors, view:'edit'
            return
        }

        log.save flush:true

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.updated.message', args: [message(code: 'log.label', default: 'Log'), log.id])
                redirect log
            }
            '*'{ respond log, [status: OK] }
        }
    }

    @Transactional
    def delete(Log log) {

        if (log == null) {
            transactionStatus.setRollbackOnly()
            notFound()
            return
        }

        log.delete flush:true

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.deleted.message', args: [message(code: 'log.label', default: 'Log'), log.id])
                redirect action:"index", method:"GET"
            }
            '*'{ render status: NO_CONTENT }
        }
    }

    protected void notFound() {
        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.not.found.message', args: [message(code: 'log.label', default: 'Log'), params.id])
                redirect action: "index", method: "GET"
            }
            '*'{ render status: NOT_FOUND }
        }
    }
}

grails-app/views/log/create.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'device.label', default: 'Device')}" />
        <title><g:message code="default.create.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#create-device" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="create-device" class="content scaffold-create" role="main">
            <h1><g:message code="default.create.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <g:hasErrors bean="${this.device}">
            <ul class="errors" role="alert">
                <g:eachError bean="${this.device}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
                </g:eachError>
            </ul>
            </g:hasErrors>
            <g:form action="save">
                <fieldset class="form">
                    <f:all bean="device"/>
                </fieldset>
                <fieldset class="buttons">
                    <g:submitButton name="create" class="save" value="${message(code: 'default.button.create.label', default: 'Create')}" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>

grails-app/views/log/edit.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'log.label', default: 'Log')}" />
        <title><g:message code="default.edit.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#edit-log" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="edit-log" class="content scaffold-edit" role="main">
            <h1><g:message code="default.edit.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <g:hasErrors bean="${this.log}">
            <ul class="errors" role="alert">
                <g:eachError bean="${this.log}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
                </g:eachError>
            </ul>
            </g:hasErrors>
            <g:form resource="${this.log}" method="PUT">
                <g:hiddenField name="version" value="${this.log?.version}" />
                <fieldset class="form">
                    <f:all bean="log"/>
                </fieldset>
                <fieldset class="buttons">
                    <input class="save" type="submit" value="${message(code: 'default.button.update.label', default: 'Update')}" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>

grails-app/views/log/index.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'log.label', default: 'Log')}" />
        <title><g:message code="default.list.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#list-log" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                
            </ul>
        </div>
        <div id="list-log" class="content scaffold-list" role="main">
            <h1><g:message code="default.list.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>


            <table>
                <thead>
                    <tr>
                        <th>Device Name</th>
                        <th>Device Mode</th>
                        <th>Date Created</th>
                       
                    </tr>
                </thead>
                <tbody>
                <g:each var="log" in="${logList}">
                    <tr>
                        <td>
                        <g:link controller="device" action="show" id="${log.device.id}">
                        ${log.device.name}</g:link>
                        </td>
                        <td><g:if test="${log.deviceMode==false}">Off</g:if>
                        <g:else>On</g:else>
                        </td>
                        <td>${log.dateCreated}</td>
                        
                        
                    </tr>
                </g:each>


                </tbody>
            </table>

            <div class="pagination">
                <g:paginate total="${logCount ?: 0}" />
            </div>
        </div>
    </body>
</html>

grails-app/views/log/show.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'log.label', default: 'Log')}" />
        <title><g:message code="default.show.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#show-log" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
                
            </ul>
        </div>
        <div id="show-log" class="content scaffold-show" role="main">
            <h1><g:message code="default.show.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>

            <ul class="property-list">
                <li class="fieldcontain">
                    <span id="dateCreated" class="dateCreated" style="clear:right; padding-right:260px;" >
                    <g:message message="Date Created"/></span>
                    <span class="dateCreated-value" aria-labelledby="dateCreated">${log.dateCreated}
                    </span>
                </li>

                <li class="fieldcontain">
                    <span id="deviceName" class="deviceName" style="clear:right; padding-right:260px;" >
                    <g:message message="Device Name"/></span>
                    <span class="deviceName-value" aria-labelledby="deviceName">${log.deviceName}
                    </span>
                </li>

                <li class="fieldcontain">
                    <span id="deviceMode" class="deviceMode" style="clear:right; padding-right:260px;" >
                    <g:message message="Device Mode"/></span>
                    <span class="deviceMode-value" aria-labelledby="deviceMode">
                        <g:if test="${log.device.mode}">On</g:if>
                        <g:else>Off</g:else>
                    </span>
                </li>

                <li class="fieldcontain">
                    <span id="device" class="device" style="clear:right; padding-right:300px;" >
                    <g:message message="Device"/></span>
                    <span class="device-value" aria-labelledby="device">
                    <g:link controller="device" action="show" id="${log.device.id}">
                    ${log.device.name}</g:link>
                    </span>

                </li>
            </ul>

            <g:form resource="${this.log}" method="DELETE">
                <fieldset class="buttons">
                    
                    <input class="delete" type="submit" value="${message(code: 'default.button.delete.label', default: 'Delete')}" onclick="return confirm('${message(code: 'default.button.delete.confirm.message', default: 'Are you sure?')}');" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>